package fr.openium.consentium_ui.ui.components.core.toggle

import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.height
import androidx.compose.material3.Switch
import androidx.compose.material3.SwitchDefaults
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import fr.openium.consentium_ui.ui.components.style.ConsentiumUITheme

@Composable
internal fun ConsentiumUISwitch(
    checked: Boolean,
    onCheckedChange: (Boolean) -> Unit,
    modifier: Modifier = Modifier,
) {
    Switch(
        checked = checked,
        onCheckedChange = onCheckedChange,
        colors = SwitchDefaults.colors(
            checkedTrackColor = ConsentiumUITheme.colors.secondary,
        ),
        modifier = modifier,
    )
}

@Preview
@Composable
private fun ConsentiumUISwitchPreview() {
    Column {
        ConsentiumUISwitch(
            checked = true,
            onCheckedChange = {},
        )

        Spacer(modifier = Modifier.height(16.dp))

        ConsentiumUISwitch(
            checked = false,
            onCheckedChange = {},
        )
    }
}