package fr.openium.consentium.data.remote.mock

import fr.openium.consentium.data.remote.ConsentiumApi
import fr.openium.consentium.data.remote.model.GetConsent
import fr.openium.consentium.data.remote.model.PatchConsent
import kotlinx.coroutines.delay
import retrofit2.Response
import java.util.UUID

internal object ConsentiumMockApi : ConsentiumApi {

    private val consents = GetConsent.GetConsentPayloadDTO(
        id = UUID.randomUUID().toString(),
        installationId = UUID.randomUUID().toString(),
        purposes = listOf(
            GetConsent.PurposeDTO(
                identifier = "purpose-audience",
                vendors = null,
                choice = GetConsent.PurposeStatusDTO.ACCEPTED,
            ),
            GetConsent.PurposeDTO(
                identifier = "purpose-required",
                vendors = null,
                choice = GetConsent.PurposeStatusDTO.REJECTED,
            ),
        ),
        state = GetConsent.ConsentStateDTO.VALID,
    )

    override suspend fun getConsents(token: String): Response<GetConsent.GetConsentPayloadDTO> {
        delay(2000)
        return Response.success(consents)
    }

    override suspend fun setConsents(token: String, patchConsent: PatchConsent.PatchConsentPayloadDTO): Response<Unit> {
        delay(2000)
        return Response.success(Unit)
    }

}