package fr.openium.consentium.data.remote.model

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable

internal sealed interface PatchConsent {

    @Serializable
    data class PatchConsentPayloadDTO(
        @SerialName("consentPurposes") val purposes: List<PurposeDTO>? = null,
    )

    @Serializable
    data class PurposeDTO(
        @SerialName("identifier") val identifier: String,
        @SerialName("choice") val choice: PurposeStatusDTO,
    )

    @Serializable
    data class VendorDTO(
        @SerialName("identifier") val identifier: String,
        @SerialName("isAccepted") val isAccepted: Boolean,
    )

    @Serializable
    enum class PurposeStatusDTO {
        @SerialName("accepted")
        ACCEPTED,

        @SerialName("refused")
        REJECTED,

        @SerialName("partial")
        PARTIAL,
    }

}
